---
title: GIT
authors:
  - Marek Chalupa
  - Vladimír Štill
date: 15\. září 2017
header-includes:
    - \institute{FAKOS}
theme: metropolis
lang: czech
...


## Verzované složky / lokální verzovací systém
 * Jednoduché, ale neefektivní a nepraktické
 * Jak spolupracovat s ostatními lidmi?


 \begin{center}
 \vspace{3mm}
 \includegraphics[width=6cm]{folders.png}
 \end{center}



## Centrální verzovací systém
 * Server je bottle-neck
 * Co když není internetové spojení?


 \begin{center}
 \includegraphics[width=6cm]{centralized.png}
 {\let\thefootnote\relax\footnote{{\tiny https://git-scm.com/book/en/v2/images/centralized.png}}}
 \end{center}

## Distribuovaný verzovací systém
 * Každý počítač (klient i server) má celou kopii repozitáře

 \begin{center}
 \includegraphics[width=5cm]{distributed.png}
 {\let\thefootnote\relax\footnote{{\tiny https://git-scm.com/book/en/v2/images/distributed.png}}}
 \end{center}

## GIT
 * Distribuovaný verzovací systém
 * Většina operací jsou lokální
 * Snímky souborového systému ("snapshot"), neukládá rozdíly
 * "Commit often, perfect later, publish once."

## GIT -- pozadí
 * Git sleduje danou složku a soubory v ní
 * Soubor je buď sledovaný nebo nesledovaný (tracked/untracked)
 * Každý sledovaný soubor může být ve třech stavech:
     - unmodified / modified / staged (indexed)

 \begin{center}
 \includegraphics[width=6cm]{lifecycle.png}
 {\let\thefootnote\relax\footnote{{\tiny https://git-scm.com/book/en/v2/images/lifecycle.png}}}
 \end{center}

## První tři příkazy
 * `git init` -- initializuj repozitář v prázdné složce
 * `git add`  -- přidej obsah do následujícího commitu
 * `git commit` -- vytvoř commit

 \begin{center}
 \includegraphics[width=6cm]{areas.png}
 {\let\thefootnote\relax\footnote{{\tiny https://git-scm.com/book/en/v2/images/areas.png}}}
 \end{center}

## Prohlížení změn a historie
 * `git log`
 * GUI nástroje: `tig`, `gitk`, `gitkraken`
 * Zkusíte si s Vláďou ;)

## Vrácení změn
 * `git reset HEAD` -- odznač indexované změny ("staged" se stane "modified")
 * `git checkout -- <soubor>` -- vrať všechny změny provedené na souboru
 * `git commit --amend` -- přidej indexovaný obsah do předchozího commitu

## Vzdálené repozitáře
 * `git clone` -- stáhni novou kopii vzdáleného repozitáře
 * `git pull` -- stáhni commity ze vzdáleného repozitáře
 * `git push` -- nahraj svoje commity do vzdáleného repozitáře


## Větve
 * Způsob jak bezpečně upravovat obsah bez rozbití "publikovaných" dat
 * Ukazatel na určitý commit
 * Větvení je levné -- používejte často

 \begin{center}
 \includegraphics[width=7cm]{branches.png}
 {\let\thefootnote\relax\footnote{{\tiny https://git-scm.com/book/en/v2/images/advance-master.png}}}
 \end{center}

## Větve -- pokračování

 * `git checkout -b <nazev vetve>` -- vytvoření nové větve
 * `git checkout <nazev vetve>` -- přepínání mezi větvemi
 * `git branch` -- vypsání větví


## Tagování
 * Tag je (neměnný) ukazatel na určitý commit
 * Chovají se podobně jako větve (pull/push/checkout)
 * Může obsahovat dodatečné informace (kdo udělal tag, kdy, komentáře, ...) -- annotovaný tag

 * `git tag <nazev>`
 * `git tag -a <nazev> -m "komentar"`

## Merge a rebase

## Dobré praktiky
 * Používat větve
 * Konzistentní malé commity (jeden commit = jedna logická změna)
 * Struktura commit zprávy -- další forma dokumentace
 * Neměnit již publikované commity
